/**
 * @module parjs
 */
/** */
import { FailureReply } from "./reply";
/**
 * A parent class for all errors thrown by Parjs.
 */
export declare abstract class ParjsError extends Error {
    name: string;
}
/**
 * An error that is thrown when it is assumed a parser will succeed, but it fails.
 */
export declare class ParjsParsingFailure extends ParjsError {
    failure: FailureReply;
    constructor(failure: FailureReply);
}
/**
 * An error thrown to indicate that a parser has been constructed inappropriately.
 */
export declare class ParserDefinitionError extends ParjsError {
    parserName: string;
    constructor(parserName: string, message: string);
}
