"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @module parjs/internal/implementation/combinators
 */
/** */
const action_1 = require("../../action");
const reply_1 = require("../../../../reply");
/**
 * Created by User on 21-Nov-16.
 */
class PrsMustCapture extends action_1.ParjsAction {
    constructor(_inner, _failType) {
        super();
        this._inner = _inner;
        this._failType = _failType;
        this.isLoud = _inner.isLoud;
        this.expecting = `internal parser ${_inner.displayName} to consume input`;
    }
    _apply(ps) {
        let { _inner, _failType } = this;
        let { position } = ps;
        _inner.apply(ps);
        if (!ps.isOk) {
            return;
        }
        ps.kind = position !== ps.position ? reply_1.ReplyKind.Ok : _failType;
    }
}
exports.PrsMustCapture = PrsMustCapture;

//# sourceMappingURL=must-capture.js.map