"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @module parjs/internal/implementation/combinators
 */
/** */
const action_1 = require("../../action");
const reply_1 = require("../../../../reply");
/**
 * Created by User on 21-Nov-16.
 */
class PrsMust extends action_1.ParjsAction {
    constructor(_inner, _requirement, _failType, _qualityName) {
        super();
        this._inner = _inner;
        this._requirement = _requirement;
        this._failType = _failType;
        this._qualityName = _qualityName;
        this.isLoud = _inner.isLoud;
        this.expecting = `internal parser ${_inner.displayName} yielding a result satisfying ${_qualityName}`;
    }
    _apply(ps) {
        let { _inner, _requirement, _failType } = this;
        _inner.apply(ps);
        if (!ps.isOk) {
            return;
        }
        ps.kind = _requirement(ps.value, ps.userState) ? reply_1.ReplyKind.Ok : _failType;
    }
}
exports.PrsMust = PrsMust;

//# sourceMappingURL=must.js.map