"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @module parjs/internal/implementation/combinators
 */
/** */
const action_1 = require("../../action");
const reply_1 = require("../../../../reply");
const helpers_1 = require("../../functions/helpers");
/**
 * Created by User on 21-Nov-16.
 */
class PrsExactly extends action_1.ParjsAction {
    constructor(_inner, _count) {
        super();
        this._inner = _inner;
        this._count = _count;
        this.isLoud = _inner.isLoud;
        this.expecting = _inner.expecting;
    }
    _apply(ps) {
        let { _inner, _count, isLoud } = this;
        let arr = [];
        for (let i = 0; i < _count; i++) {
            _inner.apply(ps);
            if (!ps.isOk) {
                if (ps.kind === reply_1.ReplyKind.SoftFail && i > 0) {
                    ps.kind = reply_1.ReplyKind.HardFail;
                }
                //fail because the inner parser has failed.
                return;
            }
            helpers_1.ArrayHelpers.maybePush(arr, ps.value);
        }
        ps.value = arr;
    }
}
exports.PrsExactly = PrsExactly;

//# sourceMappingURL=exactly.js.map