"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @module parjs/internal/implementation/combinators
 */
/** */
const action_1 = require("../../action");
const reply_1 = require("../../../../reply");
/**
 * Created by User on 21-Nov-16.
 */
class PrsChoose extends action_1.ParjsAction {
    constructor(_initial, _selector) {
        super();
        this._initial = _initial;
        this._selector = _selector;
        this.isLoud = true;
        this.expecting = _initial.expecting;
    }
    _apply(ps) {
        let { _initial, _selector } = this;
        let results = [];
        _initial.apply(ps);
        if (!ps.isOk) {
            //propagate the failure of 'initial' upwards.
            return;
        }
        let next;
        let initialResult = ps.value;
        if (!next) {
            next = _selector(initialResult, ps.userState);
        }
        if (!next) {
            ps.kind = reply_1.ReplyKind.HardFail;
            ps.expecting = "failed to determine the right parser for the input";
            return;
        }
        next.action.apply(ps);
        if (ps.isSoft) {
            ps.kind = reply_1.ReplyKind.HardFail;
        }
    }
}
exports.PrsChoose = PrsChoose;

//# sourceMappingURL=sequential-func.js.map