"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @module parjs/internal/implementation/combinators
 */
/** */
const action_1 = require("../../action");
const reply_1 = require("../../../../reply");
const helpers_1 = require("../../functions/helpers");
/**
 * Created by User on 21-Nov-16.
 */
class PrsSequence extends action_1.ParjsAction {
    constructor(_parsers) {
        super();
        this._parsers = _parsers;
        this.isLoud = true;
        if (_parsers.length === 0) {
            this.expecting = "anything";
        }
        else {
            this.expecting = _parsers[0].expecting;
        }
    }
    _apply(ps) {
        let { _parsers } = this;
        let results = [];
        let origPos = ps.position;
        for (let i = 0; i < _parsers.length; i++) {
            let cur = _parsers[i];
            cur.apply(ps);
            if (ps.isOk) {
                helpers_1.ArrayHelpers.maybePush(results, ps.value);
            }
            else if (ps.isSoft && origPos === ps.position) {
                //if the first parser failed softly then we propagate a soft failure.
                return;
            }
            else if (ps.isSoft) {
                ps.kind = reply_1.ReplyKind.HardFail;
                //if a i > 0 parser failed softly, this is a hard fail for us.
                //also, propagate the internal expectation.
                return;
            }
            else {
                //ps failed hard or fatally. The same severity.
                return;
            }
        }
        ps.value = results;
        ps.kind = reply_1.ReplyKind.Ok;
    }
}
exports.PrsSequence = PrsSequence;

//# sourceMappingURL=sequential.js.map