"use strict";
/**
 * @module parjs/internal/implementation/parsers
 */ /** */
Object.defineProperty(exports, "__esModule", { value: true });
const action_1 = require("../../action");
const reply_1 = require("../../../../reply");
/**
 * Created by User on 24-Nov-16.
 */
class PrsCharCodeWhere extends action_1.ParjsBasicAction {
    constructor(_predicate, property = "(a specific property)") {
        super();
        this._predicate = _predicate;
        this.isLoud = true;
        this.expecting = `any character satisfying ${property}.`;
    }
    _apply(ps) {
        let { _predicate } = this;
        let { position, input } = ps;
        if (position >= input.length) {
            ps.kind = reply_1.ReplyKind.SoftFail;
            return;
        }
        let curChar = input.charCodeAt(position);
        if (!_predicate(curChar)) {
            ps.kind = reply_1.ReplyKind.SoftFail;
            return;
        }
        ps.value = String.fromCharCode(curChar);
        ps.position++;
        ps.kind = reply_1.ReplyKind.Ok;
    }
}
exports.PrsCharCodeWhere = PrsCharCodeWhere;

//# sourceMappingURL=char-code-where.js.map