"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @module parjs/internal/implementation/parsers
 */
/** */
const action_1 = require("../../action");
const parselets_1 = require("./parselets");
const reply_1 = require("../../../../reply");
const errors_1 = require("../../../../errors");
class PrsInt extends action_1.ParjsAction {
    constructor(_options) {
        super();
        this._options = _options;
        this.isLoud = true;
        if (_options.base > 36) {
            throw new errors_1.ParserDefinitionError("int", "invalid base");
        }
        this.expecting = `a ${_options.allowSign ? "signed" : "unsigned"} integer in base ${_options.base}`;
    }
    _apply(ps) {
        let { _options: { allowSign, base } } = this;
        let { position, input } = ps;
        let initPos = ps.position;
        let sign = allowSign ? parselets_1.Parselets.parseSign(ps) : 0;
        let parsedSign = false;
        if (sign !== 0) {
            parsedSign = true;
        }
        else {
            sign = 1;
        }
        position = ps.position;
        parselets_1.Parselets.parseDigitsInBase(ps, base);
        let value = parseInt(input.substring(initPos, ps.position), base);
        if (ps.position === position) {
            ps.kind = parsedSign ? reply_1.ReplyKind.HardFail : reply_1.ReplyKind.SoftFail;
        }
        else {
            ps.value = value;
            ps.kind = reply_1.ReplyKind.Ok;
        }
    }
}
exports.PrsInt = PrsInt;

//# sourceMappingURL=int.js.map