"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @module parjs/internal/implementation/parsers
 */
/** */
const action_1 = require("../../action");
const reply_1 = require("../../../../reply");
/**
 * Created by User on 24-Nov-16.
 */
class PrsRegexp extends action_1.ParjsBasicAction {
    constructor(_regexp) {
        super();
        this._regexp = _regexp;
        let flags = [_regexp.ignoreCase && "i", _regexp.multiline && "m"].filter(x => x).join("");
        let normalizedRegexp = new RegExp(_regexp.source, `${flags}y`);
        _regexp = normalizedRegexp;
        this.expecting = `input matching '${_regexp.source}'`;
    }
    _apply(ps) {
        let { input, position } = ps;
        let { _regexp } = this;
        _regexp.lastIndex = position;
        let match = _regexp.exec(input);
        if (!match) {
            ps.kind = reply_1.ReplyKind.SoftFail;
            return;
        }
        ps.position += match[0].length;
        ps.value = match.slice();
        ps.kind = reply_1.ReplyKind.Ok;
    }
}
exports.PrsRegexp = PrsRegexp;

//# sourceMappingURL=regexp.js.map