"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @module parjs/internal/implementation/parsers
 */
/** */
const action_1 = require("../../action");
const reply_1 = require("../../../../reply");
/**
 * Created by User on 22-Nov-16.
 */
class PrsStringLen extends action_1.ParjsBasicAction {
    constructor(_length) {
        super();
        this._length = _length;
        this.expecting = `${_length} characters`;
    }
    _apply(ps) {
        let { position, input } = ps;
        let { _length } = this;
        if (input.length < position + _length) {
            ps.kind = reply_1.ReplyKind.SoftFail;
            return;
        }
        ps.position += _length;
        ps.value = input.substr(position, _length);
        ps.kind = reply_1.ReplyKind.Ok;
    }
}
exports.PrsStringLen = PrsStringLen;

//# sourceMappingURL=string-len.js.map