"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @module parjs/internal/implementation/parsers
 */
/** */
const action_1 = require("../../action");
const reply_1 = require("../../../../reply");
/**
 * Created by User on 21-Nov-16.
 */
class PrsString extends action_1.ParjsBasicAction {
    constructor(_str) {
        super();
        this._str = _str;
        this.expecting = `'${_str}'`;
    }
    _apply(ps) {
        let { _str } = this;
        let { position, input } = ps;
        let i;
        if (position + _str.length > input.length) {
            ps.kind = reply_1.ReplyKind.SoftFail;
            return;
        }
        for (let i = 0; i < _str.length; i++, position++) {
            if (_str.charCodeAt(i) !== input.charCodeAt(position)) {
                ps.kind = reply_1.ReplyKind.SoftFail;
                return;
            }
        }
        ps.position += _str.length;
        ps.value = _str;
        ps.kind = reply_1.ReplyKind.Ok;
    }
}
exports.PrsString = PrsString;

//# sourceMappingURL=string.js.map