import { BaseParjsParser } from "./implementation";
import { LoudParser } from "../loud";
import { ReplyKind } from "../reply";
import { QuietParser } from "../quiet";
import { ImplicitAnyParser } from "../convertible-literal";
export declare class ParjsParser extends BaseParjsParser implements LoudParser<any>, QuietParser {
    readonly backtrack: ParjsParser;
    readonly state: LoudParser<any>;
    readonly q: ParjsParser;
    readonly soft: ParjsParser;
    readonly not: ParjsParser;
    readonly str: ParjsParser;
    thenChoose(selector: (x: any, state: any) => any): any;
    between(preceding: ImplicitAnyParser, proceeding?: ImplicitAnyParser): any;
    mustCapture(failType?: ReplyKind.Fail): ParjsParser;
    maybe(x?: any): QuietParser & LoudParser<any>;
    or(...others: any[]): any;
    map(f: any): ParjsParser;
    each(f: any): ParjsParser;
    then(...args: any[]): any;
    many(minSuccesses?: number, maxIters?: number): ParjsParser;
    manyTill(till: ImplicitAnyParser | any, tillOptional?: boolean): ParjsParser;
    manySepBy(sep: ImplicitAnyParser, maxIterations?: number): ParjsParser;
    exactly(count: number): ParjsParser;
    result(r: any): ParjsParser;
    cast<S>(): this;
    must(condition: Function, name?: string, fail?: ReplyKind.Fail): ParjsParser;
    mustNotBeOf(options: any[], fail?: "Hard"): ParjsParser;
    mustBeOf(options: any[], fail?: "Hard"): ParjsParser;
    mustBeNonEmpty(fail?: "Hard"): ParjsParser;
    withName(newName: string): this;
    isolateState(x: any): this;
    flatten(): ParjsParser;
    splat(): ParjsParser;
}
