/**
 * @module parjs/internal
 */
/** */
import { ParjsParser } from "./instance";
import { AnyParser } from "../any";
import { ReplyKind } from "../reply";
import { IntOptions } from "./implementation/parsers/numbers/int";
import { FloatOptions } from "./implementation/parsers/numbers/float";
import { LoudParser, ParjsProjection } from "../loud";
import { ParjsStatic, ParjsStaticHelper, ParserSpecification } from "../parjs";
import { AnyParserAction } from "./action";
import { StaticCodeInfo } from "char-info";
import { TraceVisualizer } from "./visualizer";
import { StaticCharInfo } from "char-info/dist/inner/abstract";
import { ImplicitAnyParser } from "../convertible-literal";
export declare const ConditionalUnicode: {
    _codeInfo: StaticCodeInfo;
    _charInfo: StaticCharInfo;
    CodeInfo: StaticCodeInfo;
    CharInfo: StaticCharInfo;
};
export declare let CodeInfo: StaticCodeInfo;
export declare let CharInfo: StaticCharInfo;
export declare class ParjsHelper implements ParjsStaticHelper {
    isParser(obj: any): obj is AnyParser;
    isParserAction(obj: any): obj is AnyParserAction;
}
export declare class ParjsParsers implements ParjsStatic {
    helper: ParjsHelper;
    visualizer: TraceVisualizer;
    constructor();
    readonly spaces1: ParjsParser;
    readonly letter: ParjsParser;
    readonly anyChar: ParjsParser;
    readonly uniLetter: ParjsParser;
    readonly digit: ParjsParser;
    readonly uniDigit: ParjsParser;
    readonly hex: ParjsParser;
    readonly uniLower: ParjsParser;
    readonly lower: ParjsParser;
    readonly upper: ParjsParser;
    readonly uniUpper: ParjsParser;
    readonly newline: ParjsParser;
    readonly uniNewline: ParjsParser;
    readonly space: ParjsParser;
    readonly uniSpace: ParjsParser;
    readonly whitespaces: ParjsParser;
    readonly uniSpaces: ParjsParser;
    readonly nop: ParjsParser;
    readonly rest: ParjsParser;
    readonly eof: ParjsParser;
    readonly position: ParjsParser;
    readonly state: ParjsParser;
    seqObject(...specs: ParserSpecification<any>[]): LoudParser<any>;
    late<T>(resolver: () => LoudParser<T>): LoudParser<T>;
    choose(selector: any): any;
    any(...parsers: ImplicitAnyParser[]): ParjsParser;
    seq(...parsers: AnyParser[]): ParjsParser;
    charWhere(predicate: ParjsProjection<string, boolean>, property?: string): ParjsParser;
    anyCharOf(options: string): ParjsParser;
    noCharOf(options: string): ParjsParser;
    string(str: string): ParjsParser;
    anyStringOf(...strs: string[]): ParjsParser;
    stringLen(length: number): ParjsParser;
    regexp(regex: RegExp): ParjsParser;
    result(x: any): ParjsParser;
    fail(expecting?: string, kind?: ReplyKind.Fail): ParjsParser;
    int(options?: IntOptions): ParjsParser;
    float(options?: FloatOptions): ParjsParser;
}
